using System.Threading.Tasks;
using InternshipSystem.Repository;
using Microsoft.AspNetCore.Mvc;

namespace Internship.Api.Controller
{
    [ApiController]
    [Route("admin")]
    public class AdminController : ControllerBase
    {
        public AdminController(DatabaseFiller fillerService)
        {
            FillerService = fillerService;
        }

        public DatabaseFiller FillerService { get; }

        
        [HttpPost("fill")] 
        public async Task<IActionResult> Fill() {
            await FillerService.FillCompany();
            await FillerService.FillInterns();
            await FillerService.FillInternshipTypes();
            await FillerService.FillEditions();
            await FillerService.FillInternShips();
            return Ok();
        }

        [HttpPost("fill/companies")]
        public async Task<IActionResult> FillCompaniesAsync()
        {
            await FillerService.FillCompany();
            return Ok();
        }

        [HttpPost("fill/interns")]
        public async Task<IActionResult> FillInternsAsync() {
            await FillerService.FillInterns();
            return Ok();
        }

        [HttpPost("fill/internshiptypes")]
        public async Task<IActionResult> FillInternshipTypesAsync() {
            await FillerService.FillInternshipTypes();
            return Ok();
        }     

        [HttpPost("fill/editions")]
        public async Task<IActionResult> FillEditionsAsync() {
            await FillerService.FillEditions();
            return Ok();
        }
        
        [HttpPost("fill/internships")]
        public async Task<IActionResult> FillInternShipsAsync() {
            await FillerService.FillInternShips();
            return Ok();
        }
    }
}